Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -63,4 +63,7 @@
 static bool should_quit = false;
 static bool dash_represents_stdin = false;
+static unsigned int lineno = 0;
+static bool number = false;
+static bool last_char_was_newline = false;
 
 static console_ctrl_t *console = NULL;
@@ -75,4 +78,5 @@
 	{ "hex", no_argument, 0, 'x' },
 	{ "stdin", no_argument, 0, 's' },
+	{ "number", no_argument, 0, 'n' },
 	{ 0, 0, 0, 0 }
 };
@@ -95,5 +99,6 @@
 		"  -m, --more       Pause after each screen full\n"
 		"  -x, --hex        Print bytes as hex values\n"
-		"  -s  --stdin      Treat `-' in file list as standard input\n"
+		"  -s, --stdin      Treat `-' in file list as standard input\n"
+		"  -n, --number     Number all output lines\n"
 		"Currently, %s is under development, some options don't work.\n",
 		cmdname, cmdname);
@@ -153,5 +158,10 @@
 static void paged_char(wchar_t c)
 {
+	if (last_char_was_newline && number) {
+		lineno++;
+		printf("%6u  ", lineno);
+	}
 	putchar(c);
+	last_char_was_newline = c == '\n';
 	if (paging_enabled) {
 		chars_remaining--;
@@ -306,9 +316,14 @@
 	should_quit = false;
 	console = console_init(stdin, stdout);
+	number = false;
+	lineno = 0;
+	/* This enables printing of the first number. */
+	last_char_was_newline = true;
+
 
 	argc = cli_count_args(argv);
 
 	for (c = 0, optind = 0, opt_ind = 0; c != -1;) {
-		c = getopt_long(argc, argv, "xhvmH:t:b:s", long_options, &opt_ind);
+		c = getopt_long(argc, argv, "xhvmH:t:b:s:n", long_options, &opt_ind);
 		switch (c) {
 		case 'h':
@@ -347,4 +362,7 @@
 			dash_represents_stdin = true;
 			break;
+		case 'n':
+			number = true;
+			break;
 		}
 	}
Index: uspace/app/dnsres/dnsres.c
===================================================================
--- uspace/app/dnsres/dnsres.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/dnsres/dnsres.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -36,49 +36,71 @@
 #include <inet/addr.h>
 #include <inet/dnsr.h>
+#include <net/socket_codes.h>
 #include <stdio.h>
 #include <stdlib.h>
 
-#define NAME "dnsres"
+#define NAME  "dnsres"
 
 static void print_syntax(void)
 {
-	printf("syntax: " NAME " <host-name>\n");
+	printf("Syntax: %s [-4|-6] <host-name>\n", NAME);
 }
 
 int main(int argc, char *argv[])
 {
-	int rc;
-	dnsr_hostinfo_t *hinfo;
-	char *hname;
-	char *saddr;
-
-	if (argc != 2) {
+	if ((argc < 2) || (argc > 3)) {
 		print_syntax();
 		return 1;
 	}
-
-	hname = argv[1];
-
-	rc = dnsr_name2host(hname, &hinfo);
+	
+	uint16_t af;
+	char *hname;
+	
+	if (str_cmp(argv[1], "-4") == 0) {
+		if (argc < 3) {
+			print_syntax();
+			return 1;
+		}
+		
+		af = AF_INET;
+		hname = argv[2];
+	} else if (str_cmp(argv[1], "-6") == 0) {
+		if (argc < 3) {
+			print_syntax();
+			return 1;
+		}
+		
+		af = AF_INET6;
+		hname = argv[2];
+	} else {
+		af = 0;
+		hname = argv[1];
+	}
+	
+	dnsr_hostinfo_t *hinfo;
+	int rc = dnsr_name2host(hname, &hinfo, af);
 	if (rc != EOK) {
-		printf(NAME ": Error resolving '%s'.\n", argv[1]);
-		return 1;
+		printf("%s: Error resolving '%s'.\n", NAME, hname);
+		return rc;
 	}
-
+	
+	char *saddr;
 	rc = inet_addr_format(&hinfo->addr, &saddr);
 	if (rc != EOK) {
 		dnsr_hostinfo_destroy(hinfo);
-		printf(NAME ": Out of memory.\n");
-		return 1;
+		printf("%s: Error formatting address.\n", NAME);
+		return rc;
 	}
-
+	
 	printf("Host name: %s\n", hname);
+	
 	if (str_cmp(hname, hinfo->cname) != 0)
 		printf("Canonical name: %s\n", hinfo->cname);
+	
 	printf("Address: %s\n", saddr);
-
+	
 	dnsr_hostinfo_destroy(hinfo);
 	free(saddr);
-
+	
 	return 0;
 }
Index: uspace/app/netecho/netecho.c
===================================================================
--- uspace/app/netecho/netecho.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/netecho/netecho.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -225,5 +225,5 @@
 	uint8_t address_buf[sizeof(struct sockaddr_in6)];
 
-	socklen_t addrlen;
+	socklen_t addrlen = sizeof(struct sockaddr_in6);
 	int socket_id;
 	ssize_t rcv_size;
@@ -240,5 +240,4 @@
 	if (type == SOCK_STREAM) {
 		/* Accept a socket if a stream socket is used */
-		addrlen = sizeof(address_buf);
 		if (verbose)
 			printf("accept()\n");
@@ -280,5 +279,5 @@
 				case AF_INET6:
 					port = ntohs(address_in6->sin6_port);
-					address_start = (uint8_t *) &address_in6->sin6_addr.s6_addr;
+					address_start = (uint8_t *) address_in6->sin6_addr.s6_addr;
 					break;
 				default:
Index: uspace/app/nettest1/nettest.c
===================================================================
--- uspace/app/nettest1/nettest.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/nettest1/nettest.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -41,5 +41,4 @@
 #include "print_error.h"
 
-
 /** Creates new sockets.
  *
@@ -52,20 +51,20 @@
  * @return Other error codes as defined for the socket() function.
  */
-int sockets_create(int verbose, int *socket_ids, int sockets, int family, sock_type_t type)
-{
-	int index;
-
+int sockets_create(int verbose, int *socket_ids, unsigned int sockets,
+    uint16_t family, sock_type_t type)
+{
 	if (verbose)
 		printf("Create\t");
-		
-	fflush(stdout);
-	
-	for (index = 0; index < sockets; index++) {
+	
+	fflush(stdout);
+	
+	for (unsigned int index = 0; index < sockets; index++) {
 		socket_ids[index] = socket(family, type, 0);
 		if (socket_ids[index] < 0) {
-			printf("Socket %d (%d) error:\n", index, socket_ids[index]);
+			printf("Socket %u (%d) error:\n", index, socket_ids[index]);
 			socket_print_error(stderr, socket_ids[index], "Socket create: ", "\n");
 			return socket_ids[index];
 		}
+		
 		if (verbose)
 			print_mark(index);
@@ -83,21 +82,19 @@
  * @return Other error codes as defined for the closesocket() function.
  */
-int sockets_close(int verbose, int *socket_ids, int sockets)
-{
-	int index;
-	int rc;
-
+int sockets_close(int verbose, int *socket_ids, unsigned int sockets)
+{
 	if (verbose)
 		printf("\tClose\t");
-
-	fflush(stdout);
-	
-	for (index = 0; index < sockets; index++) {
-		rc = closesocket(socket_ids[index]);
+	
+	fflush(stdout);
+	
+	for (unsigned int index = 0; index < sockets; index++) {
+		int rc = closesocket(socket_ids[index]);
 		if (rc != EOK) {
-			printf("Socket %d (%d) error:\n", index, socket_ids[index]);
+			printf("Socket %u (%d) error:\n", index, socket_ids[index]);
 			socket_print_error(stderr, rc, "Socket close: ", "\n");
 			return rc;
 		}
+		
 		if (verbose)
 			print_mark(index);
@@ -117,9 +114,7 @@
  * @return Other error codes as defined for the connect() function.
  */
-int sockets_connect(int verbose, int *socket_ids, int sockets, struct sockaddr *address, socklen_t addrlen)
-{
-	int index;
-	int rc;
-
+int sockets_connect(int verbose, int *socket_ids, unsigned int sockets,
+    struct sockaddr *address, socklen_t addrlen)
+{
 	if (verbose)
 		printf("\tConnect\t");
@@ -127,76 +122,93 @@
 	fflush(stdout);
 	
-	for (index = 0; index < sockets; index++) {
-		rc = connect(socket_ids[index], address, addrlen);
+	for (unsigned int index = 0; index < sockets; index++) {
+		int rc = connect(socket_ids[index], address, addrlen);
 		if (rc != EOK) {
 			socket_print_error(stderr, rc, "Socket connect: ", "\n");
 			return rc;
 		}
-		if (verbose)
-			print_mark(index);
-	}
-	
-	return EOK;
-}
-
-/** Sends data via sockets.
- *
- * @param[in] verbose A value indicating whether to print out verbose information.
- * @param[in] socket_ids A field of stored socket identifiers.
- * @param[in] sockets The number of sockets in the field. Should be at most the size of the field.
- * @param[in] address The destination host address to send data to.
- * @param[in] addrlen The length of the destination address in bytes.
- * @param[in] data The data to be sent.
- * @param[in] size The data size in bytes.
- * @param[in] messages The number of datagrams per socket to be sent.
+		
+		if (verbose)
+			print_mark(index);
+	}
+	
+	return EOK;
+}
+
+/** Send data via sockets.
+ *
+ * @param[in] verbose    Print out verbose information.
+ * @param[in] socket_ids Stored socket identifiers.
+ * @param[in] sockets    Number of sockets.
+ * @param[in] address    Destination host address to send data to.
+ * @param[in] addrlen    Length of the destination address in bytes.
+ * @param[in] data       Data to be sent.
+ * @param[in] size       Size of the data in bytes.
+ * @param[in] messages   Number of datagrams per socket to be sent.
+ * @param[in] type       Socket type.
+ *
  * @return EOK on success.
  * @return Other error codes as defined for the sendto() function.
- */
-int sockets_sendto(int verbose, int *socket_ids, int sockets, struct sockaddr *address, socklen_t addrlen, char *data, int size, int messages)
-{
-	int index;
-	int message;
-	int rc;
-
+ *
+ */
+int sockets_sendto(int verbose, int *socket_ids, unsigned int sockets,
+    struct sockaddr *address, socklen_t addrlen, char *data, size_t size,
+    unsigned int messages, sock_type_t type)
+{
 	if (verbose)
 		printf("\tSendto\t");
-
-	fflush(stdout);
-	
-	for (index = 0; index < sockets; index++) {
-		for (message = 0; message < messages; message++) {
-			rc = sendto(socket_ids[index], data, size, 0, address, addrlen);
+	
+	fflush(stdout);
+	
+	for (unsigned int index = 0; index < sockets; index++) {
+		for (unsigned int message = 0; message < messages; message++) {
+			int rc;
+			
+			switch (type) {
+			case SOCK_STREAM:
+				rc = send(socket_ids[index], data, size, 0);
+				break;
+			case SOCK_DGRAM:
+				rc = sendto(socket_ids[index], data, size, 0, address, addrlen);
+				break;
+			default:
+				rc = EINVAL;
+			}
+			
 			if (rc != EOK) {
-				printf("Socket %d (%d), message %d error:\n", index, socket_ids[index], message);
+				printf("Socket %u (%d), message %u error:\n",
+				    index, socket_ids[index], message);
 				socket_print_error(stderr, rc, "Socket send: ", "\n");
 				return rc;
 			}
 		}
-		if (verbose)
-			print_mark(index);
-	}
-	
-	return EOK;
-}
-
-/** Receives data via sockets.
- *
- * @param[in] verbose A value indicating whether to print out verbose information.
- * @param[in] socket_ids A field of stored socket identifiers.
- * @param[in] sockets The number of sockets in the field. Should be at most the size of the field.
- * @param[in] address The source host address of received datagrams.
- * @param[in,out] addrlen The maximum length of the source address in bytes. The actual size of the source address is set instead.
- * @param[out] data The received data.
- * @param[in] size The maximum data size in bytes.
- * @param[in] messages The number of datagrams per socket to be received.
+		
+		if (verbose)
+			print_mark(index);
+	}
+	
+	return EOK;
+}
+
+/** Receive data via sockets.
+ *
+ * @param[in]     verbose    Print out verbose information.
+ * @param[in]     socket_ids Stored socket identifiers.
+ * @param[in]     sockets    Number of sockets.
+ * @param[in]     address    Source host address of received datagrams.
+ * @param[in,out] addrlen    Maximum length of the source address in bytes.
+ *                           The actual size of the source address is set.
+ * @param[out]    data       Received data.
+ * @param[in]     size       Maximum data size in bytes.
+ * @param[in]     messages   Number of datagrams per socket to be received.
+ *
  * @return EOK on success.
  * @return Other error codes as defined for the recvfrom() function.
- */
-int sockets_recvfrom(int verbose, int *socket_ids, int sockets, struct sockaddr *address, socklen_t *addrlen, char *data, int size, int messages)
-{
-	int value;
-	int index;
-	int message;
-
+ *
+ */
+int sockets_recvfrom(int verbose, int *socket_ids, unsigned int sockets,
+    struct sockaddr *address, socklen_t *addrlen, char *data, size_t size,
+    unsigned int messages)
+{
 	if (verbose)
 		printf("\tRecvfrom\t");
@@ -204,62 +216,82 @@
 	fflush(stdout);
 	
-	for (index = 0; index < sockets; index++) {
-		for (message = 0; message < messages; message++) {
-			value = recvfrom(socket_ids[index], data, size, 0, address, addrlen);
-			if (value < 0) {
-				printf("Socket %d (%d), message %d error:\n", index, socket_ids[index], message);
-				socket_print_error(stderr, value, "Socket receive: ", "\n");
-				return value;
-			}
-		}
-		if (verbose)
-			print_mark(index);
-	}
-	return EOK;
-}
-
-/** Sends and receives data via sockets.
+	for (unsigned int index = 0; index < sockets; index++) {
+		for (unsigned int message = 0; message < messages; message++) {
+			int rc = recvfrom(socket_ids[index], data, size, 0, address, addrlen);
+			if (rc < 0) {
+				printf("Socket %u (%d), message %u error:\n",
+				    index, socket_ids[index], message);
+				socket_print_error(stderr, rc, "Socket receive: ", "\n");
+				return rc;
+			}
+		}
+		
+		if (verbose)
+			print_mark(index);
+	}
+	
+	return EOK;
+}
+
+/** Send and receive data via sockets.
  *
  * Each datagram is sent and a reply read consequently.
  * The next datagram is sent after the reply is received.
  *
- * @param[in] verbose A value indicating whether to print out verbose information.
- * @param[in] socket_ids A field of stored socket identifiers.
- * @param[in] sockets The number of sockets in the field. Should be at most the size of the field.
- * @param[in,out] address The destination host address to send data to. The source host address of received datagrams is set instead.
- * @param[in] addrlen The length of the destination address in bytes.
- * @param[in,out] data The data to be sent. The received data are set instead.
- * @param[in] size The data size in bytes.
- * @param[in] messages The number of datagrams per socket to be received.
+ * @param[in]     verbose    Print out verbose information.
+ * @param[in]     socket_ids Stored socket identifiers.
+ * @param[in]     sockets    Number of sockets.
+ * @param[in,out] address    Destination host address to send data to.
+ *                           The source host address of received datagrams is set.
+ * @param[in]     addrlen    Length of the destination address in bytes.
+ * @param[in,out] data       Data to be sent. The received data are set.
+ * @param[in]     size       Size of the data in bytes.
+ * @param[in]     messages   Number of datagrams per socket to be received.
+ * @param[in]     type       Socket type.
+ *
  * @return EOK on success.
  * @return Other error codes as defined for the recvfrom() function.
- */
-int sockets_sendto_recvfrom(int verbose, int *socket_ids, int sockets, struct sockaddr *address, socklen_t *addrlen, char *data, int size, int messages)
-{
-	int value;
-	int index;
-	int message;
-	int rc;
-
+ *
+ */
+int sockets_sendto_recvfrom(int verbose, int *socket_ids, unsigned int sockets,
+    struct sockaddr *address, socklen_t *addrlen, char *data,
+    size_t size, unsigned int messages, sock_type_t type)
+{
 	if (verbose)
 		printf("\tSendto and recvfrom\t");
-
-	fflush(stdout);
-	
-	for (index = 0; index < sockets; index++) {
-		for (message = 0; message < messages; message++) {
-			rc = sendto(socket_ids[index], data, size, 0, address, *addrlen);
+	
+	fflush(stdout);
+	
+	for (unsigned int index = 0; index < sockets; index++) {
+		for (unsigned int message = 0; message < messages; message++) {
+			int rc;
+			
+			switch (type) {
+			case SOCK_STREAM:
+				rc = send(socket_ids[index], data, size, 0);
+				break;
+			case SOCK_DGRAM:
+				rc = sendto(socket_ids[index], data, size, 0, address, *addrlen);
+				break;
+			default:
+				rc = EINVAL;
+			}
+			
 			if (rc != EOK) {
-				printf("Socket %d (%d), message %d error:\n", index, socket_ids[index], message);
+				printf("Socket %u (%d), message %u error:\n",
+				    index, socket_ids[index], message);
 				socket_print_error(stderr, rc, "Socket send: ", "\n");
 				return rc;
 			}
-			value = recvfrom(socket_ids[index], data, size, 0, address, addrlen);
-			if (value < 0) {
-				printf("Socket %d (%d), message %d error:\n", index, socket_ids[index], message);
-				socket_print_error(stderr, value, "Socket receive: ", "\n");
-				return value;
-			}
-		}
+			
+			rc = recvfrom(socket_ids[index], data, size, 0, address, addrlen);
+			if (rc < 0) {
+				printf("Socket %u (%d), message %u error:\n",
+				    index, socket_ids[index], message);
+				socket_print_error(stderr, rc, "Socket receive: ", "\n");
+				return rc;
+			}
+		}
+		
 		if (verbose)
 			print_mark(index);
@@ -274,6 +306,7 @@
  *
  * @param[in] index The index of the mark to be printed.
- */
-void print_mark(int index)
+ *
+ */
+void print_mark(unsigned int index)
 {
 	if ((index + 1) % 10)
@@ -281,4 +314,5 @@
 	else
 		printf("|");
+	
 	fflush(stdout);
 }
Index: uspace/app/nettest1/nettest.h
===================================================================
--- uspace/app/nettest1/nettest.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/nettest1/nettest.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -40,11 +40,15 @@
 #include <net/socket.h>
 
-extern void print_mark(int);
-extern int sockets_create(int, int *, int, int, sock_type_t);
-extern int sockets_close(int, int *, int);
-extern int sockets_connect(int, int *, int, struct sockaddr *, socklen_t);
-extern int sockets_sendto(int, int *, int, struct sockaddr *, socklen_t, char *, int, int);
-extern int sockets_recvfrom(int, int *, int, struct sockaddr *, socklen_t *, char *, int, int);
-extern int sockets_sendto_recvfrom(int, int *, int, struct sockaddr *, socklen_t *, char *, int, int);
+extern void print_mark(unsigned int);
+extern int sockets_create(int, int *, unsigned int, uint16_t, sock_type_t);
+extern int sockets_close(int, int *, unsigned int);
+extern int sockets_connect(int, int *, unsigned int, struct sockaddr *,
+    socklen_t);
+extern int sockets_sendto(int, int *, unsigned int, struct sockaddr *,
+    socklen_t, char *, size_t, unsigned int, sock_type_t);
+extern int sockets_recvfrom(int, int *, unsigned int, struct sockaddr *,
+    socklen_t *, char *, size_t, unsigned int);
+extern int sockets_sendto_recvfrom(int, int *, unsigned int, struct sockaddr *,
+    socklen_t *, char *, size_t, unsigned int, sock_type_t);
 
 #endif
Index: uspace/app/nettest1/nettest1.c
===================================================================
--- uspace/app/nettest1/nettest1.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/nettest1/nettest1.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -253,5 +253,5 @@
 	
 	rc = sockets_sendto_recvfrom(verbose, socket_ids, nsockets, address,
-	    &addrlen, data, size, nmessages);
+	    &addrlen, data, size, nmessages, type);
 	if (rc != EOK)
 		return rc;
@@ -278,5 +278,5 @@
 	
 	rc = sockets_sendto(verbose, socket_ids, nsockets, address, addrlen,
-	    data, size, nmessages);
+	    data, size, nmessages, type);
 	if (rc != EOK)
 		return rc;
@@ -335,5 +335,5 @@
 		/* Interpret as a host name */
 		dnsr_hostinfo_t *hinfo = NULL;
-		rc = dnsr_name2host(addr_s, &hinfo);
+		rc = dnsr_name2host(addr_s, &hinfo, family);
 		
 		if (rc != EOK) {
Index: uspace/app/nettest2/nettest2.c
===================================================================
--- uspace/app/nettest2/nettest2.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/nettest2/nettest2.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -271,5 +271,5 @@
 		/* Interpret as a host name */
 		dnsr_hostinfo_t *hinfo = NULL;
-		rc = dnsr_name2host(addr_s, &hinfo);
+		rc = dnsr_name2host(addr_s, &hinfo, family);
 		
 		if (rc != EOK) {
@@ -375,5 +375,5 @@
 	
 	rc = sockets_sendto_recvfrom(verbose, socket_ids, sockets, address,
-	    &addrlen, data, size, messages);
+	    &addrlen, data, size, messages, type);
 	if (rc != EOK)
 		return rc;
@@ -399,5 +399,5 @@
 	
 	rc = sockets_sendto(verbose, socket_ids, sockets, address, addrlen,
-	    data, size, messages);
+	    data, size, messages, type);
 	if (rc != EOK)
 		return rc;
Index: uspace/app/nettest3/nettest3.c
===================================================================
--- uspace/app/nettest3/nettest3.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/nettest3/nettest3.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -78,5 +78,5 @@
 		if (rc != EOK) {
 			/* Try interpreting as a host name */
-			rc = dnsr_name2host(argv[1], &hinfo);
+			rc = dnsr_name2host(argv[1], &hinfo, AF_INET);
 			if (rc != EOK) {
 				printf("Error resolving host '%s'.\n", argv[1]);
Index: uspace/app/nterm/conn.c
===================================================================
--- uspace/app/nterm/conn.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/nterm/conn.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -84,5 +84,5 @@
 		/* Interpret as a host name */
 		dnsr_hostinfo_t *hinfo = NULL;
-		rc = dnsr_name2host(addr_s, &hinfo);
+		rc = dnsr_name2host(addr_s, &hinfo, 0);
 		
 		if (rc != EOK) {
Index: uspace/app/ping/ping.c
===================================================================
--- uspace/app/ping/ping.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/ping/ping.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -42,6 +42,9 @@
 #include <inet/inetping.h>
 #include <io/console.h>
+#include <getopt.h>
 #include <stdio.h>
 #include <stdlib.h>
+#include <str.h>
+#include <str_error.h>
 #include <sys/types.h>
 
@@ -54,9 +57,19 @@
 #define PING_TIMEOUT (1000 * 1000)
 
+typedef enum {
+	RECEIVED_NONE,
+	RECEIVED_SUCCESS,
+	RECEIVED_INTERRUPT
+} received_t;
+
+static received_t received;
+static FIBRIL_CONDVAR_INITIALIZE(received_cv);
+static FIBRIL_MUTEX_INITIALIZE(received_lock);
+
+static bool quit = false;
+static FIBRIL_CONDVAR_INITIALIZE(quit_cv);
+static FIBRIL_MUTEX_INITIALIZE(quit_lock);
+
 static int ping_ev_recv(inetping_sdu_t *);
-
-static bool done = false;
-static FIBRIL_CONDVAR_INITIALIZE(done_cv);
-static FIBRIL_MUTEX_INITIALIZE(done_lock);
 
 static inetping_ev_ops_t ev_ops = {
@@ -67,17 +80,28 @@
 static addr32_t dest;
 
-static bool ping_repeat = false;
+static bool repeat_forever = false;
+static size_t repeat_count = 1;
+
+static const char *short_options = "rn:";
 
 static void print_syntax(void)
 {
-	printf("syntax: " NAME " [-r] <host>\n");
-}
-
-static void ping_signal_done(void)
-{
-	fibril_mutex_lock(&done_lock);
-	done = true;
-	fibril_mutex_unlock(&done_lock);
-	fibril_condvar_broadcast(&done_cv);
+	printf("Syntax: %s [-n <count>|-r] <host>\n", NAME);
+}
+
+static void ping_signal_received(received_t value)
+{
+	fibril_mutex_lock(&received_lock);
+	received = value;
+	fibril_mutex_unlock(&received_lock);
+	fibril_condvar_broadcast(&received_cv);
+}
+
+static void ping_signal_quit(void)
+{
+	fibril_mutex_lock(&quit_lock);
+	quit = true;
+	fibril_mutex_unlock(&quit_lock);
+	fibril_condvar_broadcast(&quit_cv);
 }
 
@@ -105,6 +129,5 @@
 	    "payload size %zu\n", asrc, adest, sdu->seq_no, sdu->size);
 	
-	if (!ping_repeat)
-		ping_signal_done();
+	ping_signal_received(RECEIVED_SUCCESS);
 	
 	free(asrc);
@@ -116,6 +139,5 @@
 {
 	inetping_sdu_t sdu;
-	int rc;
-
+	
 	sdu.src = src;
 	sdu.dest = dest;
@@ -123,12 +145,11 @@
 	sdu.data = (void *) "foo";
 	sdu.size = 3;
-
-	rc = inetping_send(&sdu);
-	if (rc != EOK) {
-		printf(NAME ": Failed sending echo request (%d).\n", rc);
-		return rc;
-	}
-
-	return EOK;
+	
+	int rc = inetping_send(&sdu);
+	if (rc != EOK)
+		printf("Failed sending echo request: %s (%d).\n",
+		    str_error(rc), rc);
+	
+	return rc;
 }
 
@@ -136,43 +157,60 @@
 {
 	uint16_t seq_no = 0;
-
+	
+	while ((repeat_count--) || (repeat_forever)) {
+		fibril_mutex_lock(&received_lock);
+		received = RECEIVED_NONE;
+		fibril_mutex_unlock(&received_lock);
+		
+		(void) ping_send(++seq_no);
+		
+		fibril_mutex_lock(&received_lock);
+		int rc = fibril_condvar_wait_timeout(&received_cv, &received_lock,
+		    PING_TIMEOUT);
+		received_t recv = received;
+		fibril_mutex_unlock(&received_lock);
+		
+		if ((rc == ETIMEOUT) || (recv == RECEIVED_NONE))
+			printf("Echo request timed out (seq. no %u)\n", seq_no);
+		
+		if (recv == RECEIVED_INTERRUPT)
+			break;
+		
+		if ((repeat_count > 0) || (repeat_forever)) {
+			fibril_mutex_lock(&received_lock);
+			rc = fibril_condvar_wait_timeout(&received_cv, &received_lock,
+			    PING_DELAY);
+			recv = received;
+			fibril_mutex_unlock(&received_lock);
+			
+			if (recv == RECEIVED_INTERRUPT)
+				break;
+		}
+	}
+	
+	ping_signal_quit();
+	return 0;
+}
+
+static int input_fibril(void *arg)
+{
+	console_ctrl_t *con = console_init(stdin, stdout);
+	
 	while (true) {
-		fibril_mutex_lock(&done_lock);
-		if (done) {
-			fibril_mutex_unlock(&done_lock);
-			return 0;
-		}
-		fibril_mutex_unlock(&done_lock);
-
-		(void) ping_send(++seq_no);
-		async_usleep(PING_DELAY);
-	}
-
-	return 0;
-}
-
-static int input_fibril(void *arg)
-{
-	console_ctrl_t *con;
-	cons_event_t ev;
-
-	con = console_init(stdin, stdout);
-	printf("[Press Ctrl-Q to quit]\n");
-
-	while (true) {
+		cons_event_t ev;
 		if (!console_get_event(con, &ev))
 			break;
-
-		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS &&
-		    (ev.ev.key.mods & (KM_ALT | KM_SHIFT)) ==
-		    0 && (ev.ev.key.mods & KM_CTRL) != 0) {
+		
+		if ((ev.type == CEV_KEY) && (ev.ev.key.type == KEY_PRESS) &&
+		    ((ev.ev.key.mods & (KM_ALT | KM_SHIFT)) == 0) &&
+		    ((ev.ev.key.mods & KM_CTRL) != 0)) {
 			/* Ctrl+key */
 			if (ev.ev.key.key == KC_Q) {
-				ping_signal_done();
-				return 0;
+				ping_signal_received(RECEIVED_INTERRUPT);
+				break;
 			}
 		}
 	}
-
+	
 	return 0;
 }
@@ -184,35 +222,47 @@
 	char *adest = NULL;
 	char *sdest = NULL;
-	int rc;
-	int argi;
-
-	rc = inetping_init(&ev_ops);
-	if (rc != EOK) {
-		printf(NAME ": Failed connecting to internet ping service "
-		    "(%d).\n", rc);
-		goto error;
-	}
-
-	argi = 1;
-	if (argi < argc && str_cmp(argv[argi], "-r") == 0) {
-		ping_repeat = true;
-		++argi;
-	} else {
-		ping_repeat = false;
-	}
-
-	if (argc - argi != 1) {
+	
+	int rc = inetping_init(&ev_ops);
+	if (rc != EOK) {
+		printf("Failed connecting to internet ping service: "
+		    "%s (%d).\n", str_error(rc), rc);
+		goto error;
+	}
+	
+	int c;
+	while ((c = getopt(argc, argv, short_options)) != -1) {
+		switch (c) {
+		case 'r':
+			repeat_forever = true;
+			break;
+		case 'n':
+			rc = str_size_t(optarg, NULL, 10, true, &repeat_count);
+			if (rc != EOK) {
+				printf("Invalid repeat count.\n");
+				print_syntax();
+				goto error;
+			}
+			break;
+		default:
+			printf("Unknown option passed.\n");
+			print_syntax();
+			goto error;
+		}
+	}
+	
+	if (optind >= argc) {
+		printf("IP address or host name not supplied.\n");
 		print_syntax();
 		goto error;
 	}
-
+	
 	/* Parse destination address */
 	inet_addr_t dest_addr;
-	rc = inet_addr_parse(argv[argi], &dest_addr);
+	rc = inet_addr_parse(argv[optind], &dest_addr);
 	if (rc != EOK) {
 		/* Try interpreting as a host name */
-		rc = dnsr_name2host(argv[argi], &hinfo);
+		rc = dnsr_name2host(argv[optind], &hinfo, AF_INET);
 		if (rc != EOK) {
-			printf(NAME ": Error resolving host '%s'.\n", argv[argi]);
+			printf("Error resolving host '%s'.\n", argv[optind]);
 			goto error;
 		}
@@ -223,6 +273,6 @@
 	uint16_t af = inet_addr_get(&dest_addr, &dest, NULL);
 	if (af != AF_INET) {
-		printf(NAME ": Destination '%s' is not an IPv4 address.\n",
-		    argv[argi]);
+		printf("Destination '%s' is not an IPv4 address.\n",
+		    argv[optind]);
 		goto error;
 	}
@@ -231,5 +281,5 @@
 	rc = inetping_get_srcaddr(dest, &src);
 	if (rc != EOK) {
-		printf(NAME ": Failed determining source address.\n");
+		printf("Failed determining source address.\n");
 		goto error;
 	}
@@ -240,5 +290,5 @@
 	rc = inet_addr_format(&src_addr, &asrc);
 	if (rc != EOK) {
-		printf(NAME ": Out of memory.\n");
+		printf("Out of memory.\n");
 		goto error;
 	}
@@ -246,5 +296,5 @@
 	rc = inet_addr_format(&dest_addr, &adest);
 	if (rc != EOK) {
-		printf(NAME ": Out of memory.\n");
+		printf("Out of memory.\n");
 		goto error;
 	}
@@ -253,5 +303,5 @@
 		rc = asprintf(&sdest, "%s (%s)", hinfo->cname, adest);
 		if (rc < 0) {
-			printf(NAME ": Out of memory.\n");
+			printf("Out of memory.\n");
 			goto error;
 		}
@@ -260,43 +310,29 @@
 		adest = NULL;
 	}
-
-	printf("Sending ICMP echo request from %s to %s.\n",
+	
+	printf("Sending ICMP echo request from %s to %s (Ctrl+Q to quit)\n",
 	    asrc, sdest);
-
-	fid_t fid;
-
-	if (ping_repeat) {
-		fid = fibril_create(transmit_fibril, NULL);
-		if (fid == 0) {
-			printf(NAME ": Failed creating transmit fibril.\n");
-			goto error;
-		}
-
-		fibril_add_ready(fid);
-
-		fid = fibril_create(input_fibril, NULL);
-		if (fid == 0) {
-			printf(NAME ": Failed creating input fibril.\n");
-			goto error;
-		}
-
-		fibril_add_ready(fid);
-	} else {
-		ping_send(1);
-	}
-
-	fibril_mutex_lock(&done_lock);
-	rc = EOK;
-	while (!done && rc != ETIMEOUT) {
-		rc = fibril_condvar_wait_timeout(&done_cv, &done_lock,
-			ping_repeat ? 0 : PING_TIMEOUT);
-	}
-	fibril_mutex_unlock(&done_lock);
-
-	if (rc == ETIMEOUT) {
-		printf(NAME ": Echo request timed out.\n");
-		goto error;
-	}
-
+	
+	fid_t fid = fibril_create(transmit_fibril, NULL);
+	if (fid == 0) {
+		printf("Failed creating transmit fibril.\n");
+		goto error;
+	}
+	
+	fibril_add_ready(fid);
+	
+	fid = fibril_create(input_fibril, NULL);
+	if (fid == 0) {
+		printf("Failed creating input fibril.\n");
+		goto error;
+	}
+	
+	fibril_add_ready(fid);
+	
+	fibril_mutex_lock(&quit_lock);
+	while (!quit)
+		fibril_condvar_wait(&quit_cv, &quit_lock);
+	fibril_mutex_unlock(&quit_lock);
+	
 	free(asrc);
 	free(adest);
